﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Net;
using System;  
using System.Collections.Generic;  
using System.Linq;  
using System.Text;  
using System.Net.Security;  
using System.Security.Cryptography.X509Certificates;  
using System.DirectoryServices.Protocols; 
using System.ServiceModel.Security;  
using System.Net;  
using System.IO;  
using System.IO.Compression;  
using System.Text.RegularExpressions;

public partial class httpPost : System.Web.UI.Page
{

    private static readonly string DefaultUserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; SV1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";

    private static String URL = "https://mertest.chinapnr.com/pay/refundreceive.htm";

    protected void Page_Load(object sender, EventArgs e)
    {

        string inputCharset = Request["inputCharset"].ToString();
        string bgUrl = Request.Params["bgUrl"].ToString();
        string language = Request.Params["language"].ToString();
        string signType = Request.Params["signType"].ToString();
        string signMsg = Request.Params["signMsg"].ToString();
        string version = Request.Params["version"].ToString();
        string merchantAcctId = Request.Params["merchantAcctId"].ToString();
        string terminalId = Request.Params["terminalId"].ToString();
        String refundOrderId = Request.Params["refundOrderId"].ToString();
        String originalOrderId = Request.Params["originalOrderId"].ToString();
        String refundCurrency = Request.Params["refundCurrency"].ToString();
        String refundAmount = Request.Params["refundAmount"].ToString();
        String refundDesc = Request.Params["refundDesc"].ToString();

        string ext1 = "";
        if (Request.Params["ext1"] != null)
        {
            ext1 = Request.Params["ext1"].ToString();
        }

        //扩展字段2，该值与提交时相同。
        string ext2 = "";
        if (Request.Params["ext2"] != null)
        {
            ext2 = Request.Params["ext2"].ToString();
        }
        ;

        Encoding encoding = Encoding.GetEncoding("utf-8");

        IDictionary<string, string> parameters = new Dictionary<string, string>();
        parameters.Add("inputCharset", inputCharset);
        parameters.Add("bgUrl", bgUrl);
        parameters.Add("language", language);
        parameters.Add("signType", signType);
        parameters.Add("signMsg", signMsg);
        parameters.Add("version", version);
        parameters.Add("merchantAcctId", merchantAcctId);
        parameters.Add("terminalId", terminalId);
        parameters.Add("refundOrderId", refundOrderId);
        parameters.Add("originalOrderId", originalOrderId);
        parameters.Add("refundCurrency", refundCurrency);
        parameters.Add("refundAmount", refundAmount);
        parameters.Add("refundDesc", refundDesc);        
        parameters.Add("ext1", ext1);
        parameters.Add("ext2", ext2);


        HttpWebResponse response = CreatePostHttpResponse(URL, parameters, null, null, encoding, null);

        if (response.StatusCode == HttpStatusCode.OK)
        {
            System.IO.Stream responseStream = response.GetResponseStream();
            System.IO.StreamReader reader = new System.IO.StreamReader(responseStream, Encoding.UTF8);
            string respTxt = reader.ReadToEnd();
            if (respTxt.Length==0)
            {
                Response.Write("网关系统异常,返回内容为空");
                return;
            }

            receiveData(respTxt);

            return;
        }
        Response.Write("网关系统异常,返回码[" + response.StatusCode + "]");

        string cookieString = response.Headers["Set-Cookie"];

    }

    /// <summary>  
    /// 创建POST方式的HTTP请求  
    /// </summary>  
    /// <param name="url">请求的URL</param>  
    /// <param name="parameters">随同请求POST的参数名称及参数值字典</param>  
    /// <param name="timeout">请求的超时时间</param>  
    /// <param name="userAgent">请求的客户端浏览器信息，可以为空</param>  
    /// <param name="requestEncoding">发送HTTP请求时所用的编码</param>  
    /// <param name="cookies">随同HTTP请求发送的Cookie信息，如果不需要身份验证可以为空</param>  
    /// <returns></returns>  
    public static HttpWebResponse CreatePostHttpResponse(string url, IDictionary<string, string> parameters, int? timeout, string userAgent, Encoding requestEncoding, CookieCollection cookies)
    {
        if (string.IsNullOrEmpty(url))
        {
            throw new ArgumentNullException("url");
        }
        if (requestEncoding == null)
        {
            throw new ArgumentNullException("requestEncoding");
        }
        HttpWebRequest request = null;
        //如果是发送HTTPS请求  
        if (url.StartsWith("https", StringComparison.OrdinalIgnoreCase))
        {
            ServicePointManager.ServerCertificateValidationCallback = new RemoteCertificateValidationCallback(CheckValidationResult);
            request = WebRequest.Create(url) as HttpWebRequest;
            request.ProtocolVersion = HttpVersion.Version10;
        }
        else
        {
            request = WebRequest.Create(url) as HttpWebRequest;
        }
        request.Method = "POST";
        request.ContentType = "application/x-www-form-urlencoded";

        if (!string.IsNullOrEmpty(userAgent))
        {
            request.UserAgent = userAgent;
        }
        else
        {
            request.UserAgent = DefaultUserAgent;
        }

        if (timeout.HasValue)
        {
            request.Timeout = timeout.Value;
        }
        if (cookies != null)
        {
            request.CookieContainer = new CookieContainer();
            request.CookieContainer.Add(cookies);
        }
        //如果需要POST数据  
        if (!(parameters == null || parameters.Count == 0))
        {
            StringBuilder buffer = new StringBuilder();
            int i = 0;
            foreach (string key in parameters.Keys)
            {
                if (i > 0)
                {
                    buffer.AppendFormat("&{0}={1}", key, parameters[key]);
                }
                else
                {
                    buffer.AppendFormat("{0}={1}", key, parameters[key]);
                }
                i++;
            }
            var postData = string.Join("&", parameters.Select(
                p => string.Format("{0}={1}", p.Key, System.Web.HttpUtility.UrlEncode(p.Value, requestEncoding))).ToArray());

            byte[] data = requestEncoding.GetBytes(postData);
            using (Stream stream = request.GetRequestStream())
            {
                stream.Write(data, 0, data.Length);
            }
        }
        return request.GetResponse() as HttpWebResponse;
    }

    private static bool CheckValidationResult(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors errors)
    {
        return true; //总是接受  
    }  

    //验签
    private  void receiveData(String respTxt)
    {
        Dictionary<string, string> dic = new Dictionary<string, string>(); 
        string[] respArray=Regex.Split(respTxt,"&");

        foreach(String resp in respArray)
        {
             string[] keyArray=Regex.Split(resp,"=");

             if ((keyArray != null) && (keyArray.Length == 2)) {
                  dic.Add(keyArray[0], keyArray[1]);
             } else if ((keyArray != null) && (keyArray.Length == 1)) {
                  dic.Add(keyArray[0], "");
             }
        }

        //人民币网关账号，
        string merchantAcctId = dic["merchantAcctId"];
        //终端号
        string terminalId = dic["terminalId"];
        //商户订单号
        string refundOrderId = dic["refundOrderId"];
        //原交易订单号
        string originalOrderId = dic["originalOrderId"];
        //退款币别
        string refundCurrency = dic["refundCurrency"];
        //退款金额
        string refundAmount = dic["refundAmount"];
        //退款结果，10-成功，11-失败
        string refundResult = dic["refundResult"];
        //错误码，000000为成功，其他失败
        string errCode = dic["errCode"];
        string errorMsg = "";
        //错误描述
        if (dic.ContainsKey("errorMsg"))
        {
             errorMsg = dic["errorMsg"];
        }
        //系统处理流水号
        string dealId = "";
        if (dic.ContainsKey("dealId"))
        {
            dealId = dic["dealId"];
        }
        //系统处理时间
        string dealTime = "";
        if (dic.ContainsKey("dealTime"))
        {
            dealTime = dic["dealTime"];
        }
        //可退余额
        string refundBalance = "";
        if (dic.ContainsKey("refundBalance"))
        {
            refundBalance = dic["refundBalance"];
        }
        //签名串
        string signMsg = dic["signMsg"];

       //扩展字段1，该值与提交时相同。
        string ext1 = "";
        if (dic.ContainsKey("ext1"))
        {
            ext1 = dic["ext1"];
        }
        //扩展字段2，该值与提交时相同。
        string ext2 = "";
        if (dic.ContainsKey("ext2"))
        {
            ext2 = dic["ext2"];
        }

        string signMsgVal = "";
        signMsgVal = appendParam(signMsgVal, "dealId", dealId);
        signMsgVal = appendParam(signMsgVal, "dealTime", dealTime);
        signMsgVal = appendParam(signMsgVal, "errCode", errCode);
        signMsgVal = appendParam(signMsgVal, "ext1", ext1);
        signMsgVal = appendParam(signMsgVal, "ext2", ext2);
        signMsgVal = appendParam(signMsgVal, "merchantAcctId", merchantAcctId);
        signMsgVal = appendParam(signMsgVal, "originalOrderId", originalOrderId);
        signMsgVal = appendParam(signMsgVal, "refundAmount", refundAmount);
        signMsgVal = appendParam(signMsgVal, "refundBalance", refundBalance);
        signMsgVal = appendParam(signMsgVal, "refundCurrency", refundCurrency);
        signMsgVal = appendParam(signMsgVal, "refundOrderId", refundOrderId);
        signMsgVal = appendParam(signMsgVal, "refundResult", refundResult);
        signMsgVal = appendParam(signMsgVal, "terminalId", terminalId);


        ///UTF-8编码  GB2312编码  用户可以根据自己网站的编码格式来选择加密的编码方式
        ///byte[] bytes = Encoding.GetEncoding("GB2312").GetBytes(signMsgVal);
        String signMsgDecode = HttpUtility.UrlDecode(signMsg);
        byte[] bytes = System.Text.Encoding.UTF8.GetBytes(signMsgVal);
        byte[] SignatureByte = Convert.FromBase64String(signMsgDecode);
        X509Certificate2 cert = new X509Certificate2(Server.MapPath("ChinaPnR.rsa.cer"), "");
        RSACryptoServiceProvider rsapri = (RSACryptoServiceProvider)cert.PublicKey.Key;
        rsapri.ImportCspBlob(rsapri.ExportCspBlob(false));
        RSAPKCS1SignatureDeformatter f = new RSAPKCS1SignatureDeformatter(rsapri);
        byte[] result;
        f.SetHashAlgorithm("SHA1");
        SHA1CryptoServiceProvider sha = new SHA1CryptoServiceProvider();
        result = sha.ComputeHash(bytes);

        String verifySignature = "";
 //       Response.Write("错误码：" + errCode);
       

        if (f.VerifySignature(result, SignatureByte))
        {

           verifySignature = "true";

        }
        else {
           verifySignature = "false";
        }
        Response.Redirect("show.aspx?errCode=" + errCode + "&errorMsg=" + errorMsg + "&refundOrderId=" + refundOrderId + "&refundAmount=" + refundAmount + "&verifySignature=" + verifySignature + "&refundResult=" + refundResult);

    }

//功能函数。将变量值不为空的参数组成字符串
 String appendParam(String returnStr, String paramId, String paramValue)
    {

        if (returnStr != "")
        {

            if (paramValue != "")
            {

                returnStr += "&" + paramId + "=" + paramValue;
            }

        }
        else
        {

            if (paramValue != "")
            {
                returnStr = paramId + "=" + paramValue;
            }
        }

        return returnStr;
    }
}