﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
public partial class Send : System.Web.UI.Page
{
    #region 参数说明
    //编码方式，1代表 UTF-8;  默认为1,该参数必填。
    public string inputCharset = "1";
    //服务器接收支付结果的后台地址
    public string bgUrl = "http://localhost:63789/receiveBg.aspx";
    //网关版本，与原交易对应网关版本保持一致。
    public string version = "3.0";
    //语言种类，1代表中文显示，2代表英文显示。默认为1,该参数必填。
    public string language = "1";
    //签名类型,该值为4，代表PKI加密方式,该参数必填。
    public string signType = "4";
    //商户会员号
    public string merchantAcctId = "1001215986001";
    //交易终端号
    public string terminalId = "0010003";
    //商户订单号，以下采用时间来定义订单号，商户可以根据自己订单号的定义规则来定义该值，不能为空。
    public string refundOrderId = DateTime.Now.ToString("yyyyMMddHHmmss");
    //原交易商户订单号，必填。
    public string originalOrderId = "20170728150810";
    //原交易订单币别，必填。
    public string refundCurrency = "CNY";
    //退款订单金额，金额以“分”为单位，根据消费交易金额，可全额或部分退款。该参数必填。
    public string refundAmount = "10";
    //分账明细，仅分账网关必填，其他网关均为空。
    public string divDetails = ""; 
    //退款说明，可以为空。
    public string refundDesc = "七天无理由退货";
    //扩展字段1，商户可以传递自己需要的参数，支付完会原值返回，可以为空。
    public string ext1 = "";
    //扩展自段2，商户可以传递自己需要的参数，支付完会原值返回，可以为空。
    public string ext2 = "";


    // signMsg 签名字符串 不可空，生成加密签名串
    public string signMsg = "";
    #endregion
    protected void Page_Load(object sender, EventArgs e)
    {
        //拼接字符串
        string signMsgVal = "";
        signMsgVal = appendParam(signMsgVal, "inputCharset", inputCharset);
        signMsgVal = appendParam(signMsgVal, "bgUrl", bgUrl);
        signMsgVal = appendParam(signMsgVal, "version", version);
        signMsgVal = appendParam(signMsgVal, "language", language);
        signMsgVal = appendParam(signMsgVal, "signType", signType);
        signMsgVal = appendParam(signMsgVal, "merchantAcctId", merchantAcctId);
	    signMsgVal = appendParam(signMsgVal, "terminalId", terminalId);
        signMsgVal = appendParam(signMsgVal, "refundOrderId", refundOrderId);
        signMsgVal = appendParam(signMsgVal, "originalOrderId", originalOrderId);
        signMsgVal = appendParam(signMsgVal, "refundCurrency", refundCurrency);
        signMsgVal = appendParam(signMsgVal, "refundAmount", refundAmount);
        signMsgVal = appendParam(signMsgVal, "divDetails", divDetails);
        signMsgVal = appendParam(signMsgVal, "ext1", ext1);
        signMsgVal = appendParam(signMsgVal, "ext2", ext2);


        ///PKI加密
	///编码方式UTF-8 GB2312  用户可以根据自己系统的编码选择对应的加密方式
        ///byte[] OriginalByte=Encoding.GetEncoding("GB2312").GetBytes(OriginalString);
        byte[] bytes = System.Text.Encoding.UTF8.GetBytes(signMsgVal);
        X509Certificate2 cert = new X509Certificate2(HttpContext.Current.Server.MapPath("10012159860.pfx"), "123456", X509KeyStorageFlags.MachineKeySet);
        RSACryptoServiceProvider rsapri = (RSACryptoServiceProvider)cert.PrivateKey;
        RSAPKCS1SignatureFormatter f = new RSAPKCS1SignatureFormatter(rsapri);
        byte[] result;
        f.SetHashAlgorithm("SHA1");
        SHA1CryptoServiceProvider sha = new SHA1CryptoServiceProvider();
        result = sha.ComputeHash(bytes);
        signMsg = System.Convert.ToBase64String(f.CreateSignature(result)).ToString();
      

    }

    //功能函数。将变量值不为空的参数组成字符串
    #region 字符串串联函数
    public string appendParam(string returnStr, string paramId, string paramValue)
    {
        if (returnStr != "")
        {
            if (paramValue != "")
            {
                returnStr += "&" + paramId + "=" + paramValue;
            }
        }
        else
        {
            if (paramValue != "")
            {
                returnStr = paramId + "=" + paramValue;
            }
        }
        return returnStr;
    }
    #endregion
}
